> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create a debit memo from an invoice

POST https://rest.test.zuora.com/v1/debit-memos/invoice/{invoiceKey}
Content-Type: application/json

**Note:** This operation is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. 

Creates an ad-hoc debit memo from an invoice.

You can create a debit memo from an invoice only if you have the user permission. See [Billing Roles](https://knowledgecenter.zuora.com/CF_Users_and_Administrators/A_Administrator_Settings/User_Roles/d_Billing_Roles) for more information.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/debit-memos/post-debit-memo-from-invoice

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `invoiceKey` (string, required) — The ID or number of an invoice that you want to create a debit memo from. For example, 2c93808457d787030157e030d10f3f64 or INV00000001.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a DebitMemoFromInvoiceRequest.

- `invoiceId` (string, required) — The ID of the invoice that the debit memo is created from.
- `autoPay` (boolean, optional) — Whether debit memos are automatically picked up for processing in the corresponding payment run. By default, debit memos are automatically picked up for processing in the corresponding payment run.
- `autoPost` (boolean, optional, default: false) — Whether to automatically post the debit memo after it is created. Setting this field to `true`, you do not need to separately call the [Post debit memo](https://developer.zuora.com/api-references/api/operation/PUT_PostDebitMemo) operation to post the debit memo.
- `billToContactId` (string, optional) — The ID of the bill-to contact associated with the debit memo. **Note**: This field is available only if you have Flexible Billing Attributes enabled for your tenant.
- `comment` (string, optional) — Comments about the debit memo.
- `effectiveDate` (date, optional) — The date when the debit memo takes effect.
- `items` (list of DebitMemoItemFromInvoiceItemType, optional) — Container for items. The maximum number of items is 1,000.
- `reasonCode` (string, optional) — A code identifying the reason for the transaction. The value must be an existing reason code or empty. If you do not specify a value, Zuora uses the default reason code.
- `soldToContactId` (string, optional) — The ID of the sold-to contact associated with the debit memo. **Note**: This field is available only if you have Flexible Billing Attributes enabled for your tenant.
- `soldToSameAsBillTo` (boolean, optional) — Whether the sold-to contact and bill-to contact are the same entity. The created debit memo has the same bill-to contact and sold-to contact entity only when all the following conditions are met in the request body: - This field is set to `true`. - The `billToContactId` field is specified. - The `soldToContactId` field is not specified.
- `taxAutoCalculation` (boolean, optional, default: true) — Whether to automatically calculate taxes in the debit memo.
- `IntegrationId__NS` (string, optional) — ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `IntegrationStatus__NS` (string, optional) — Status of the debit memo's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SyncDate__NS` (string, optional) — Date when the debit memo was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).

## Response

### 200

OK

- `accountId` (string, optional) — The ID of the customer account associated with the debit memo.
- `accountNumber` (string, optional) — The number of the customer account associated with the debit memo.
- `amount` (double, optional) — The total amount of the debit memo.
- `autoPay` (boolean, optional) — Whether debit memos are automatically picked up for processing in the corresponding payment run. By default, debit memos are automatically picked up for processing in the corresponding payment run.
- `balance` (double, optional) — The balance of the debit memo.
- `beAppliedAmount` (double, optional) — The amount that is applied to the debit memo.
- `billToContactId` (string, optional, nullable) — The ID of the bill-to contact associated with the debit memo. The value of this field is `null` if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled.
- `billToContactSnapshotId` (string, optional, nullable) — The ID of the bill-to contact snapshot associated with the debit memo. The value of this field is `null` if the bill rule [Preserve snapshot of bill-to and sold-to contacts when billing documents are posted](https://knowledgecenter.zuora.com/Zuora_Billing/Billing_and_Invoicing/Billing_Settings/Define_Billing_Rules#Preserve_snapshot_of_bill-to_and_sold-to_contacts_when_billing_documents_are_posted) is disabled.
- `cancelledById` (string, optional, nullable) — The ID of the Zuora user who cancelled the debit memo.
- `cancelledOn` (string, optional, nullable) — The date and time when the debit memo was cancelled, in `yyyy-mm-dd hh:mm:ss` format.
- `currency` (string, optional, nullable) — The currency of the debit memo. **Note:** By default, the currency on a billing document matches the default currency set on the associated account. However, Zuora now offers a Multiple Currencies feature to support different currencies for billing documents, allowing flexibility beyond the account-level currency. For more information, see Multiple Currency.
- `comment` (string, optional, nullable) — Comments about the debit memo.
- `createdById` (string, optional) — The ID of the Zuora user who created the debit memo.
- `createdDate` (string, optional) — The date and time when the debit memo was created, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-01 15:31:10.
- `debitMemoDate` (date, optional) — The date when the debit memo takes effect, in `yyyy-mm-dd` format. For example, 2017-05-20.
- `dueDate` (date, optional) — The date by which the payment for the debit memo is due, in `yyyy-mm-dd` format.
- `einvoiceErrorCode` (string, optional, nullable) — The error code returned when the e-invoice file status is `Failed`. This code can either be a Zuora-generated error code or one returned by a third-party e-invoicing service provider. **Note**: This field is available only if you have the E-Invoicing feature in **Early Adopter** phase enabled.
- `einvoiceErrorMessage` (string, optional, nullable) — The error message returned when the e-invoice file status is `Failed`. This message can either be a Zuora-generated error message or one returned by a third-party e-invoicing service provider. **Note**: This field is available only if you have the E-Invoicing feature in **Early Adopter** phase enabled.
- `einvoiceFileId` (string, optional, nullable) — The ID of the e-invoice file generated for the debit memo. **Note**: This field is available only if you have the E-Invoicing feature in **Early Adopter** phase enabled.
- `einvoiceStatus` (enum, optional, nullable) — The status of the e-invoice file generation for the debit memo. * If e-invoice file generation succeeds, this field is either `Generated` or `Success`, and both the error code and message are empty, and the `eInvoiceFileId` field stores the ID of the generated e-invoice file. * If the responses from tax vendors such as Sovos or Avalara are taking too long, this field becomes `RetrieveTimeOut`. Once the vendor responds successfully, you can use the 'Resync E-Invoice Status' action to update the status automatically. You can view these updates in System Health telemetry. * If a failure occurs during e-invoice file generation, this field is `Failed` and an error code and an error message are returned respectively in the `einvoiceErrorCode` and `einvoiceErrorMessage` fields. * If e-invoice file generation conditionally succeeds, this field is `ConditionalSuccess` and an error code and an error message are returned respectively in the `einvoiceErrorCode` and `einvoiceErrorMessage` fields. * If the e-invoice file has been approved by the tax authority, this field is `ApprovedByAuthority`. The next status will be either `Success` or `Rejected`. * If the e-invoice file has been rejected by the government, this field is `Rejected`. You cannot resend this e-invoice; you must create a new invoice instead. **Note**: This field is available only if you have the E-Invoicing feature in **Early Adopter** phase enabled.
  - Allowed values: `Processing`, `RetrieveTimeOut`, `Generated`, `Success`, `Failed`, `ConditionalSuccess`, `ApprovedByAuthority`, `Rejected`
- `excludeItemBillingFromRevenueAccounting` (boolean, optional) — The flag to exclude the debit memo item from revenue accounting. **Note**: This field is only available if you have the Billing - Revenue Integration feature enabled.
- `id` (string, optional) — The unique ID of the debit memo.
- `invoiceGroupNumber` (string, optional, nullable) — The number of the invoice group associated with the debit memo. The value of this field is `null` if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled.
- `latestPDFFileId` (string, optional) — The ID of the latest PDF file generated for the debit memo.
- `number` (string, optional) — The unique identification number of the debit memo.
- `organizationLabel` (string, optional) — The organization that this object belongs to. Note: This field is available only when the Multi-Org feature is enabled.
- `paymentTerm` (string, optional) — The name of the payment term assoicated with the debit memo. The value of this field is `null` if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled.
- `postedById` (string, optional, nullable) — The ID of the Zuora user who posted the debit memo.
- `postedOn` (string, optional, nullable) — The date and time when the debit memo was posted, in `yyyy-mm-dd hh:mm:ss` format.
- `reasonCode` (string, optional) — A code identifying the reason for the transaction. The value must be an existing reason code or empty.
- `referredCreditMemoId` (string, optional) — The ID of the credit memo from which the debit memo was created.
- `referredInvoiceId` (string, optional, nullable) — The ID of a referred invoice.
- `sequenceSetId` (string, optional, nullable) — The ID of the sequence set associated with the debit memo. The value of this field is `null` if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled.
- `communicationProfileId` (string, optional, nullable) — The ID of the communication profile associated with the debit memo. **Note**: This field is available in the request body only if you have the Flexible Billing Attributes feature turned on. The value is `null` in the response body without this feature turned on.
- `soldToContactId` (string, optional, nullable) — The ID of the sold-to contact associated with the debit memo. The value of this field is `null` if you have the Flexible Billing Attributes feature disabled.
- `soldToContactSnapshotId` (string, optional, nullable) — The ID of the sold-to contact snapshot associated with the debit memo. The value of this field is `null` if you have the Flexible Billing Attributes feature disabled.
- `sourceType` (enum, optional) — The type of the debit memo source.
  - Allowed values: `Subscription`, `Standalone`, `Order`, `Consolidation`, `Invoice`, `CreditMemo`
- `status` (enum, optional) — The status of the debit memo.
  - Allowed values: `Draft`, `Posted`, `Canceled`, `Error`, `PendingForTax`, `Generating`, `CancelInProgress`
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.
- `targetDate` (date, optional, nullable) — The target date for the debit memo, in `yyyy-mm-dd` format. For example, 2017-07-20.
- `taxAmount` (double, optional) — The amount of taxation.
- `taxMessage` (string, optional, nullable) — The message about the status of tax calculation related to the debit memo. If tax calculation fails in one debit memo, this field displays the reason for the failure.
- `taxStatus` (enum, optional, nullable) — The status of tax calculation related to the debit memo. **Note**: This field is only applicable to tax calculation by third-party tax engines. Also, the `Voided` status indicates that the tax transaction is successfully canceled on the tax vendor's side. If a tax transaction was successfully committed to the third-party tax engine but the invoice failed to post, Zuora automatically detects the issue and voids the tax transaction on the vendor's side.
  - Allowed values: `Complete`, `Error`, `UnknownError`, `DuplicateDoc`, `InvalidRequest`, `InvalidResponse`, `TaxEngineError`, `ConcurrentModify`, `InternalServerError`, `TaxCodeTemplateError`, `Voided`
- `totalTaxExemptAmount` (double, optional) — The calculated tax amount excluded due to the exemption.
- `transferredToAccounting` (enum, optional) — Whether the debit memo was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite.
  - Allowed values: `Processing`, `Yes`, `No`, `Error`, `Ignore`
- `updatedById` (string, optional) — The ID of the Zuora user who last updated the debit memo.
- `updatedDate` (string, optional) — The date and time when the debit memo was last updated, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-02 15:36:10.
- `IntegrationId__NS` (string, optional) — ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `IntegrationStatus__NS` (string, optional) — Status of the debit memo's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SyncDate__NS` (string, optional) — Date when the debit memo was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### DebitMemoItemFromInvoiceItemType

Container for custom fields of a Debit Memo Item object.

- `amount` (double, required) — The amount of the debit memo item.
- `skuName` (string, required) — The name of the charge associated with the invoice.
- `description` (string, optional) — The description of the debit memo item. **Note**: This field is available only if you are on the latest Zuora API version, or you set the `Zuora-Version` request header to `257.0` or a later available version.
- `financeInformation` (DebitMemoItemFromInvoiceItemTypeFinanceInformation, optional) — Container for the finance information related to the debit memo item.
- `invoiceItemId` (string, optional) — The ID of the invoice item.
- `quantity` (double, optional) — The number of units for the debit memo item.
- `serviceEndDate` (date, optional) — The service end date of the debit memo item.
- `serviceStartDate` (date, optional) — The service start date of the debit memo item.
- `taxItems` (list of DebitMemoTaxItemFromInvoiceTaxItemType, optional) — Container for taxation items.
- `taxMode` (enum, optional, default: TaxExclusive) — The tax mode of the debit memo item, indicating whether the amount of the debit memo item includes tax. **Note**: You can set this field to `TaxInclusive` only if the `taxAutoCalculation` field is set to `true`. If you set `taxMode` to `TaxInclusive`, you cannot input tax amounts for debit memo items. The corresponding invoice item must use the same tax engine as the debit memo item to calculate tax amounts.
  - Allowed values: `TaxExclusive`, `TaxInclusive`
- `unitOfMeasure` (string, optional) — The definable unit that you measure when determining charges.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### DebitMemoItemFromInvoiceItemTypeFinanceInformation

Container for the finance information related to the debit memo item.

- `deferredRevenueAccountingCode` (string, optional) — The accounting code for the deferred revenue, such as Monthly Recurring Liability.
- `recognizedRevenueAccountingCode` (string, optional) — The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges.
- `revenueRecognitionRuleName` (string, optional) — The name of the revenue recognition rule governing the revenue schedule.

### DebitMemoTaxItemFromInvoiceTaxItemType

- `amount` (double, required) — The amount of the debit memo taxation item.
- `financeInformation` (DebitMemoTaxItemFromInvoiceTaxItemTypeFinanceInformation, optional) — Container for the finance information related to the source taxation item.
- `jurisdiction` (string, optional) — The jurisdiction that applies the tax or VAT. This value is typically a state, province, county, or city.
- `locationCode` (string, optional) — The identifier for the location based on the value of the `taxCode` field.
- `sourceTaxItemId` (string, optional) — The ID of the source taxation item.
- `taxCode` (string, optional) — The tax code identifies which tax rules and tax rates to apply to a specific debit memo.
- `taxCodeDescription` (string, optional) — The description of the tax code.
- `taxDate` (date, optional) — The date that the tax is applied to the debit memo, in `yyyy-mm-dd` format.
- `taxExemptAmount` (double, optional) — The calculated tax amount excluded due to the exemption.
- `taxName` (string, optional) — The name of taxation.
- `taxRate` (double, optional) — The tax rate applied to the debit memo.
- `taxRateDescription` (string, optional) — The description of the tax rate.
- `taxRateType` (enum, optional) — The type of the tax rate applied to the debit memo.
  - Allowed values: `Percentage`, `FlatFee`

### DebitMemoTaxItemFromInvoiceTaxItemTypeFinanceInformation

Container for the finance information related to the source taxation item.

- `salesTaxPayableAccountingCode` (string, optional) — The accounting code for the sales taxes payable.

## Examples

**Request**

```json
{
  "invoiceId": "8a90cc5c9301541f01930186636b1400",
  "effectiveDate": "2024-11-11",
  "items": [
    {
      "amount": 10,
      "skuName": "SKU-00000591",
      "invoiceItemId": "8a90cc5c9301541f0193018663aa1413"
    }
  ],
  "reasonCode": "Correcting invoice error"
}
```

**Response**

```json
{
  "accountId": "8a90b4488e7d5c0f018e7db3892400b2",
  "accountNumber": "A00000370",
  "amount": 10,
  "autoPay": true,
  "balance": 10,
  "beAppliedAmount": 0,
  "billToContactId": "8a90b4488e7d5c0f018e7db3896100b4",
  "billToContactSnapshotId": null,
  "cancelledById": null,
  "cancelledOn": null,
  "currency": "USD",
  "comment": null,
  "createdById": "2c92c8f95e2d6ebb015e325df48e02da",
  "createdDate": "2024-11-11 12:30:23",
  "debitMemoDate": "2024-11-11",
  "dueDate": "2024-12-11",
  "id": "8a90a19d9310bb3c0193197cb4700501",
  "invoiceGroupNumber": null,
  "latestPDFFileId": null,
  "number": "DM00000045",
  "paymentTerm": "Net 30",
  "postedById": null,
  "postedOn": null,
  "reasonCode": "Correcting invoice error",
  "referredCreditMemoId": null,
  "referredInvoiceId": "8a90cc5c9301541f01930186636b1400",
  "sequenceSetId": "acd16fac492111e9a0d70cc47a32b062",
  "soldToContactId": null,
  "soldToContactSnapshotId": null,
  "sourceType": "Invoice",
  "status": "Draft",
  "success": true,
  "targetDate": null,
  "taxAmount": 0,
  "taxMessage": null,
  "taxStatus": null,
  "totalTaxExemptAmount": 0,
  "transferredToAccounting": "Processing",
  "updatedById": "2c92c8f95e2d6ebb015e325df48e02da",
  "updatedDate": "2024-11-11 12:30:23",
  "eInvoiceErrorCode": null,
  "eInvoiceErrorMessage": null,
  "eInvoiceFileId": null,
  "eInvoiceStatus": null
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/debit-memos/invoice/invoiceKey"

payload = {
    "invoiceId": "8a90cc5c9301541f01930186636b1400",
    "effectiveDate": "2024-11-11",
    "items": [
        {
            "amount": 10,
            "skuName": "SKU-00000591",
            "invoiceItemId": "8a90cc5c9301541f0193018663aa1413"
        }
    ],
    "reasonCode": "Correcting invoice error"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/debit-memos/invoice/invoiceKey';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"invoiceId":"8a90cc5c9301541f01930186636b1400","effectiveDate":"2024-11-11","items":[{"amount":10,"skuName":"SKU-00000591","invoiceItemId":"8a90cc5c9301541f0193018663aa1413"}],"reasonCode":"Correcting invoice error"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/debit-memos/invoice/invoiceKey"

	payload := strings.NewReader("{\n  \"invoiceId\": \"8a90cc5c9301541f01930186636b1400\",\n  \"effectiveDate\": \"2024-11-11\",\n  \"items\": [\n    {\n      \"amount\": 10,\n      \"skuName\": \"SKU-00000591\",\n      \"invoiceItemId\": \"8a90cc5c9301541f0193018663aa1413\"\n    }\n  ],\n  \"reasonCode\": \"Correcting invoice error\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/debit-memos/invoice/invoiceKey")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"invoiceId\": \"8a90cc5c9301541f01930186636b1400\",\n  \"effectiveDate\": \"2024-11-11\",\n  \"items\": [\n    {\n      \"amount\": 10,\n      \"skuName\": \"SKU-00000591\",\n      \"invoiceItemId\": \"8a90cc5c9301541f0193018663aa1413\"\n    }\n  ],\n  \"reasonCode\": \"Correcting invoice error\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/debit-memos/invoice/invoiceKey")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"invoiceId\": \"8a90cc5c9301541f01930186636b1400\",\n  \"effectiveDate\": \"2024-11-11\",\n  \"items\": [\n    {\n      \"amount\": 10,\n      \"skuName\": \"SKU-00000591\",\n      \"invoiceItemId\": \"8a90cc5c9301541f0193018663aa1413\"\n    }\n  ],\n  \"reasonCode\": \"Correcting invoice error\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/debit-memos/invoice/invoiceKey', [
  'body' => '{
  "invoiceId": "8a90cc5c9301541f01930186636b1400",
  "effectiveDate": "2024-11-11",
  "items": [
    {
      "amount": 10,
      "skuName": "SKU-00000591",
      "invoiceItemId": "8a90cc5c9301541f0193018663aa1413"
    }
  ],
  "reasonCode": "Correcting invoice error"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/debit-memos/invoice/invoiceKey");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"invoiceId\": \"8a90cc5c9301541f01930186636b1400\",\n  \"effectiveDate\": \"2024-11-11\",\n  \"items\": [\n    {\n      \"amount\": 10,\n      \"skuName\": \"SKU-00000591\",\n      \"invoiceItemId\": \"8a90cc5c9301541f0193018663aa1413\"\n    }\n  ],\n  \"reasonCode\": \"Correcting invoice error\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "invoiceId": "8a90cc5c9301541f01930186636b1400",
  "effectiveDate": "2024-11-11",
  "items": [
    [
      "amount": 10,
      "skuName": "SKU-00000591",
      "invoiceItemId": "8a90cc5c9301541f0193018663aa1413"
    ]
  ],
  "reasonCode": "Correcting invoice error"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/debit-memos/invoice/invoiceKey")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```